import pandas as pd
import scipy.stats as ss
import numpy as np
import mymodule as mm

flnm = input('Data File Name (*.xlsx) = ')

fout_nm = 'q_' + flnm[:-4] + 'txt'
fout = open(fout_nm, 'w')
fout.write('Data file = ' + flnm)

xlsx = pd.ExcelFile(flnm)   
data = pd.read_excel(xlsx)

X = data.values[1:]
ndata = len(X)
print('ndata = ', ndata)

indx = data.columns.values
cndtn = data.values[0]
nvar = len(indx)
print('nvar = ', nvar)
print('indx =\n', indx)
print('cndtn =\n', cndtn)


temp_df = pd.DataFrame()
for i in range(nvar):
    if (cndtn[i] < 0):
        print('condition for var-{} < 0'.format(i))
        raise 'var_cond error.'
    else:
        if (cndtn[i] == 0):
            temp_df[indx[i]] = X[:, i]
        elif (cndtn[i] == 1):
            temp_df[indx[i] + '_z'] = ss.zscore([x for x in X[:, i]])
        else:
            nq, varnames, qvars = mm.common_q(cndtn[i], indx[i], X[:, i], fout)
            for j in range(nq):
                temp_df[varnames[j]] = qvars[j]
                

with  pd.ExcelWriter('cq_' + flnm) as xl_writer:
    temp_df.to_excel(xl_writer, index = False)
print('\nQuantified Data was saved in ' + 'cq_' + flnm)
fout.write('\n\nOutput file = ' + 'cq_' + flnm)
    
fout.close()
print('\nLog file = ' + fout_nm + '\n')
